#ifndef TANGO_DCE_HPP
#define TANGO_DCE_HPP

#include "tango/ir.hpp"
#include "tango/live_analyser.hpp"

namespace tango {

//----------------------------------------------------------------------------//

template <bool BUNDLE>
class DeadCodeEliminator : public LiveAnalyser {
public:
  explicit DeadCodeEliminator(Ir* ir) : LiveAnalyser(ir, PhaseName::DCE) {}

  void iterate();
  void iterateByBundles(BundleList&);
  void iterateByInsts(InstList&);
};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO_DCE_HPP
