#pragma once

#include "tango/compile_phase.hpp"
#include "tango/clone_helper.hpp"

namespace tango {

//----------------------------------------------------------------------------//

class LandPeep : public CompilePhase {
public:
  LandPeep(Ir* ir) : CompilePhase(ir, PhaseName::LPP) {}

protected:
  Inst *mergeToLandP(Block *btop, Block *bsec, Block *btail, Inst *curr_landp);
  bool processPhis(Block* bsec, Block* brem, Block* btail, bool do_modify, RegOpnd* ct_pred, bool inverted);
  bool validBranch(Block *branch);
  void mergeSimpleConnectors();

  virtual void run_internal();
};

//----------------------------------------------------------------------------//

}
