#ifndef TANGO_DESSA_HPP
#define TANGO_DESSA_HPP

#include "tango/compile_phase.hpp"

namespace tango {

//----------------------------------------------------------------------------//

class DeSSA : public CompilePhase {
public:
  DeSSA(Ir* ir) : CompilePhase(ir, PhaseName::SSA) {}

protected:
  void  insertCopy(Opnd*, Opnd*, Block*);
  virtual void run_internal();

};

//----------------------------------------------------------------------------//

}      // namespace tango
#endif // TANGO DESSA HPP
